
Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         org       100h

; ------ pprava pkazovho dku

Start:   mov       si,81h
         mov       bl,ds:[si-1]
         mov       bh,0
         mov       ds:[si+bx],bh

; ------ test, zda je nco zadno

         call      RozbSpc                  ; vyputn mezer
         jc        Start04                  ; nen nic zadno

; ------ inicializace pracovnho disku

         call      InitDisk                 ; inicializace disku

; ------ inicializace stop disku

         call      InitTrk                  ; inicializace stop disku

; ------ rozbor pkazovho dku

         call      Rozbor                   ; rozbor pkazovho dku
         jnc       Start1                   ; zadn OK

; ------ zobrazen npovdy

Start04: mov       dx,offset HelpTxt
         call      DispTxt
         mov       ax,4cffh
         int       21h

; ------ vpis informac o disku

Start1:  test      byte ptr ds:[Zadano],1
         jz        Start2
         call      DispInf                  ; zobrazen informac o disku
;         call      DispCop                  ; zobrazen Copyright

; ------ zobrazen obsahu disku

Start2:  test      byte ptr ds:[Zadano],2
         jz        Start3
         call      Vypis                    ; vpis obsahu disku

; ------ stop pehrvn

Start3:  test      byte ptr ds:[Zadano],4
         jz        Start32
         call      StopCD                   ; zastaven pehrvn

; ------ pokraovn pehrvn

Start32: test      byte ptr ds:[Zadano],8
         jz        Start34
         call      ContCD                   ; pokraovn v pehrvn

; ------ ten z disku

Start34:
;test      byte ptr ds:[Zadano],10h
;         jz        Start35
;         call      ReadCD                   ; ten z disku

; ------ pehrt nahrvky

Start35: test      byte ptr ds:[Zadano],20h
         jz        Start36
         call      StopCD                   ; zastaven pehrvn
         call      PlayCD                   ; pehrt nahrvky

; ------ zobrazen stavu

Start36: test      byte ptr ds:[Zadano],40h
         jz        Start37
         call      DispCD                   ; zobrazen stavu

Start37:


; ------ test stavu disku

Start8:  call      TestCD                   ; test stavu disku
         mov       ax,4c00h                 ; 0 = pehrv
         jnc       Start9                   ; pehrv OK
         inc       ax                       ; 1 = nepehrv
Start9:  int       21h

; -----------------------------------------------------------------------------
;        zobrazen informac o disku
; -----------------------------------------------------------------------------
;
DispInf  PROC      NEAR

; ------ zobrazen textu verze

         mov       dx,offset InfoTxt1
         call      DispTxt

; ------ detekce verze ovladae

         xor       bx,bx                    ; BX <- 0
         mov       al,0ch
         call      Int2F0                   ; detekce verze ovladae
         or        bh,bh                    ; MAJOR verze
         jnz       DispInf1
         mov       bx,100h                  ; je to verze 1.00

; ------ zobrazen sla verze

DispInf1:mov       al,bh                    ; MAJOR verze
         mov       ah,0
         call      DispNum                  ; zobrazen sla verze MAJOR
         mov       al,"."
         call      DispChr                  ; oddlovac teka
         mov       al,bl                    ; MINOR verze
         call      Disp2Num                 ; zobrazen sla verze MINOR

; ------ dal st textu

         mov       dx,offset InfoTxt2
         call      DispTxt

; ------ zobrazen potu nahrvek na disku

         mov       al,ds:[EndTrack]         ; posledn stopa
         sub       al,ds:[BegTrack]         ; poet nahrvek - 1
         mov       ah,0
         inc       ax                       ; poet nahrvek na disku
         call      DispNum                  ; zobrazen potu nahrvek na disku

; ------ celkov hrac doba disku

         mov       ax,word ptr ds:[KonecAdr] ; adresa koncov stopy
         mov       dx,word ptr ds:[KonecAdr+2]
         sub       ax,word ptr ds:[BeginAdr] ; odeten potku asu
         sbb       dx,word ptr ds:[BeginAdr+2]

; ------ dekdovn dlky disku

         mov       di,offset InfoTx42
         call      DekHodin                 ; dekdovn hodiny
         call      DekTimeF                 ; dekdovn asu ve tvaru MM:SS,FF

; ------ dal st textu

         mov       dx,offset InfoTxt4
         call      DispTxt

; ------ velikost sektoru

         mov       word ptr ds:[ZarizBuf],7 + 0*256 ; funkce zjitn sektoru
         mov       word ptr ds:[ZarizBuf+2],2048 ; pednastaven sektoru
         mov       cx,3                     ; poet bajt k naten
         call      InpIOCTL                 ; naten velikosti sektoru
         mov       ax,word ptr ds:[ZarizBuf+2] ; velikost sektoru
         call      DispNum                  ; zobrazen velikosti sektoru

         push      ax                       ; schova velikosti sektoru

; ------ dal st textu

         mov       dx,offset InfoTxt5
         call      DispTxt

; ------ poet sektor

         mov       byte ptr ds:[ZarizBuf],8
         mov       cx,4
         call      InpIOCTL
         mov       ax,word ptr ds:[ZarizBuf+1] ; poet sektor celkem
         mov       dx,word ptr ds:[ZarizBuf+3]
         call      DispDNum                 ; zobrazen potu sektor

; ------ dal st textu

         push      dx
         mov       dx,offset InfoTxt6
         call      DispTxt
         pop       dx

; ------ velikost disku v MB

         pop       cx                       ; CX <- velikost sektoru
         call      MulCX                    ; velikost disku v B
         xchg      ax,dx
         mov       dx,bx                    ; velikost / 2^16
         mov       cx,16                    ; jet 4 dy, aby bylo 2^20
         call      DivCX                    ; velikost v MB
         call      DispDNum                 ; zobrazen velikosti v MB

; ------ dal st textu

         mov       dx,offset InfoTxt7
         call      DispTxt

;; ------ naten UPC kdu
;
;         push      ds
;         pop       es
;         mov       di,offset ZarizBuf
;         mov       ax,0eh + 1*256
;         cld
;         stosw
;         xor       ax,ax
;         mov       cx,10/2
;         rep       stosw
;         mov       cl,11
;         call      InpIOCTL                 ; naten kdu UPC
;
;; ------ zobrazen kdu UPC
;
;         mov       si,offset ZarizBuf+2
;DispInf4:cld
;         lodsb
;         push      ax
;         mov       cl,4
;         shr       al,cl
;         add       al,"0"
;         call      DispChr
;         pop       ax
;         cmp       si,offset ZarizBuf+2+7
;         jae       DispInf5
;         and       al,0fh
;         add       al,"0"
;         call      DispChr
;         jmp       short DispInf4
;
;; ------ dal st textu
;
;DispInf5:mov       dx,offset InfoTxt8
;         call      DispTxt


         ret

DispInf  ENDP

;; -----------------------------------------------------------------------------
;;        zobrazen Copyright disku
;; -----------------------------------------------------------------------------
;;
;DispCop  PROC      NEAR
;
;         mov       dx,offset CopyrTxt
;         call      DispTxt
;;
;         mov       cl,ds:[Disk]
;         mov       ch,0
;         mov       al,5 ;2
;         mov       si,offset Pozadav
;         mov       byte ptr ds:[si],0
;         xor       dx,dx
;         call      Int2f
;
;         mov       cx,38
;         cld
;DispCop2:lodsb
;         cmp       al," "
;         jb        DispCop3
;         cmp       al,"$"
;         je        DispCop3
;         loop      DispCop2
;
;DispCop3:mov       word ptr ds:[si-1],'"' + 13*256
;         mov       word ptr ds:[si+1],10 + "$"*256
;
;         mov       dx,offset Pozadav
;         call      DispTxt
;         ret
;
;DispCop  ENDP
;
; -----------------------------------------------------------------------------
;        vpis obsahu disku
; -----------------------------------------------------------------------------
;
Vypis    PROC      NEAR

         mov       al,ds:[BegTrack]         ; poten stopa
         mov       ds:[Track],al            ; aktuln stopa

; ------ parametry aktuln stopy

Vypis1:  mov       ax,word ptr ds:[NextAdr] ; adresa pt stopy
         mov       word ptr ds:[TrackAdr],ax ; je to adresa tto stopy
         mov       ax,word ptr ds:[NextAdr+2]
         mov       word ptr ds:[TrackAdr+2],ax
         mov       al,ds:[NextInfo]         ; informan bajt
         mov       ds:[TrckInfo],al

; ------ naten dal stopy

         mov       al,ds:[Track]            ; aktuln stopa
         inc       ax                       ; pt stopa
         call      GetTrack                 ; naten dal stopy
         mov       word ptr ds:[NextAdr],ax ; adresa dal stopy
         mov       word ptr ds:[NextAdr+2],dx
         mov       al,ds:[ZarizBuf+6]       ; stavov bajt
         mov       ds:[NextInfo],al         ; informan bajt

; ------ dekdovn sla aktivn stopy

         mov       al,ds:[Track]            ; aktivn stopa
         push      ds
         pop       es
         mov       di,offset StopaTxt+9
         call      DekNumB
         cmp       byte ptr ds:[StopaTxt+9],"0"
         jne       Vypis3
         mov       byte ptr ds:[StopaTxt+9]," "

; ------ poten as stopy

Vypis3:  mov       ax,word ptr ds:[TrackAdr] ; adresa tto stopy
         mov       dx,word ptr ds:[TrackAdr+2]
         sub       ax,word ptr ds:[BeginAdr] ; odeten potku asu
         sbb       dx,word ptr ds:[BeginAdr+2]
         add       ax,word ptr ds:[KorTime] ; as potku vpisu
         adc       dx,word ptr ds:[KorTime+2]

; ------ dekdovn potenho asu stopy

         mov       di,offset StopaTxt       ; hodina
         call      DekHodin                 ; dekdovn hodiny
         call      DekMinut                 ; dekdovn minuty
         call      DekSeknd                 ; dekdovn sekundy

; ------ dlka stopy

         mov       ax,word ptr ds:[NextAdr] ; pt stopa
         mov       dx,word ptr ds:[NextAdr+2]
         sub       ax,word ptr ds:[TrackAdr] ; dlka stopy
         sbb       dx,word ptr ds:[TrackADr+2]

; ------ dekdovn dlky stopy

         mov       di,offset StopaTx2
         mov       byte ptr ds:[di-1],"."
         push      di
         call      DekTimeF                 ; dekdovn asu ve tvaru MM:SS,FF
         pop       di
         cmp       byte ptr ds:[di],"0"
         je        Vypis32
         dec       di
Vypis32: mov       byte ptr ds:[di]," "

; ------ zobrazen dku stopy

         mov       dx,offset StopaTxt
         call      DispTxt

; ------ zobrazen informac o stop

         test      byte ptr ds:[TrckInfo],40h ; je datov stopa ?
         jz        Vypis42                  ; nen datov stopa
         mov       dx,offset DataTxt
         call      DispTxt
         jmp       short Vypis46

Vypis42: test      byte ptr ds:[TrckInfo],80h ; quadro ?
         jz        Vypis44
         mov       dx,offset QuadTxt
         call      DispTxt

Vypis44: test      byte ptr ds:[TrckInfo],10h ; preemfze ?
         jz        Vypis46
         mov       dx,offset PreemTxt
         call      DispTxt

Vypis46: test      byte ptr ds:[TrckInfo],20h ; zkaz digitln kopie ?
         jz        Vypis48                  ; nen zkaz
         mov       dx,offset ProtTxt        ; zkaz digitln kopie
         call      DispTxt

Vypis48: mov       dx,offset CRTxt
         call      DispTxt

; ------ pprava pro dal stopu

         inc       byte ptr ds:[Track]      ; zven aktivn stopy
         mov       al,ds:[Track]            ; aktivn stopa
         cmp       al,ds:[EndTrack]         ; je to platn stopa ?
         ja        Vypis6
         jmp       Vypis1                   ; dal stopa

; ------ koncov as disku

Vypis6:  mov       ax,word ptr ds:[NextAdr] ; adresa dal stopy (tj. konce)
         mov       dx,word ptr ds:[NextAdr+2]
         sub       ax,word ptr ds:[BeginAdr] ; odeten potku asu
         sbb       dx,word ptr ds:[BeginAdr+2]
         add       ax,word ptr ds:[KorTime] ; as potku vpisu
         adc       dx,word ptr ds:[KorTime+2]

; ------ dekdovn koncovho asu disku

         mov       di,offset KonecTxt       ; hodina
         call      DekHodin                 ; dekdovn hodiny
         call      DekMinut                 ; dekdovn minuty
         call      DekSeknd                 ; dekdovn sekundy

; ------ celkov dlka disku

         mov       ax,word ptr ds:[NextAdr] ; adresa dal stopy
         mov       dx,word ptr ds:[NextAdr+2]
         sub       ax,word ptr ds:[BeginAdr] ; odeten potku asu
         sbb       dx,word ptr ds:[BeginAdr+2]

; ------ dekdovn dlky disku

         mov       di,offset KonecTx2+2
;         call      DekHodin                 ; dekdovn hodiny
         call      DekTimeH                 ; dekdovn asu ve tvaru MM:SS,FF
;         cmp       byte ptr ds:[KonecTx2],"0"
;         jne       Vypis7
;         mov       word ptr ds:[KonecTx2],"  "

; ------ zobrazen informac o disku

Vypis7:  mov       dx,offset KonecTxt
         call      DispTxt
         ret

Vypis    ENDP

; -----------------------------------------------------------------------------
;        ten ze zazen CD-ROM (CX bajt)
; -----------------------------------------------------------------------------

InpIOCTL PROC      NEAR

; ------ inicializace bufferu poadavku

         push      cx                       ; poet tench bajt

         call      NulPozad                 ; nulovn bufferu poadavku
         mov       al,26                    ; dlka poadavku
         stosb
         mov       al,ds:[Disk]             ; aktivn disk
         stosb
         mov       al,3                     ; povel pro ten z IOCTL
         stosb
         mov       di,offset Pozadav+0eh
         mov       ax,offset ZarizBuf       ; adresa poadavku
         stosw                              ; offset adresy
         mov       ax,ds
         stosw                              ; segment adresy
         pop       ax                       ; poet tench bajt
         push      ax
         stosw                              ; poet bajt k naten

; ------ vysln poadavku

         mov       al,10h                   ; podfunkce ovldn zazen
         mov       cl,ds:[Disk]             ; aktivn disk
         mov       ch,0
         call      Int2F                    ; vysln poadavku

; ------ kontrola navrcenho stavu

         pop       ax
         test      byte ptr ds:[Zadano],40h ; zobrazen ?
         jnz       InpIOCT4                 ; je zobrazen
         cmp       ax,word ptr ds:[Pozadav+12h] ; souhlas poet bajt ?
         jne       InpIOCT3                 ; poet bajt nesouhlas
         test      byte ptr ds:[Pozadav+3+1],80h ; byla chyba ?
         jz        InpIOCT4                 ; nebyla chyba

InpIOCT3:mov       dx,offset ReadyTxt       ; text - nen pipraven
         jmp       Chyba                    ; chyba

InpIOCT4:ret

InpIOCTL ENDP

; -----------------------------------------------------------------------------
;        test stavu CD, zda pehrv (CY=nepehrv) -> DX:AX
; -----------------------------------------------------------------------------

TestCD   PROC      NEAR

;; ------ stav disku
;
;         mov       byte ptr ds:[ZarizBuf],6 ; funkce zjitn stavu disku
;         mov       cx,4                     ; poet bajt k naten
;         call      InpIOCTL                 ; naten stavu disku
;         mov       ax,word ptr ds:[ZarizBuf+1] ; stav disku
;         test      al,1                     ; jsou dvka otevena ?
;         jnz       TestCD1                  ; dvka jsou otevena
;         test      ah,4                     ; pehrv se ?
;         jz        TestCD1                  ; nepehrv se

; ------ stav pehrvn audio

         mov       byte ptr ds:[ZarizBuf],0fh ; funkce zjitn stavu audia
         mov       cx,10                    ; poet bajt k naten
         call      InpIOCTL                 ; naten velikosti sektoru
         mov       ax,word ptr ds:[ZarizBuf+3] ; pehrvac adresa
         or        ax,word ptr ds:[ZarizBuf+5] ; probh pehrvn ?
         jz        TestCD1                  ; neprobh pehrvn

         mov       ax,word ptr ds:[ZarizBuf+1] ; stav LOW
         test      al,1                     ; pehrv ?
         jz        TestCD2                  ; pehrv
TestCD1: stc                                ; pznak, e nepehrv
TestCD2: ret

TestCD   ENDP

;; -----------------------------------------------------------------------------
;;        rychlopehrvn (AX sektor)
;; -----------------------------------------------------------------------------
;
;; ------ inicializace bufferu poadavku
;
;RychlCD: push      ax
;
;         call      NulPozad                 ; nulovn bufferu poadavku
;         mov       al,16h                   ; dlka poadavku
;         stosb
;         mov       al,ds:[Disk]             ; aktivn disk
;         stosb
;         mov       al,84h
;         stosb                              ; povel
;
;         mov       di,offset Pozadav+0dh
;         mov       al,1
;         stosb
;
;         mov       ax,word ptr ds:[PlayAdr]
;         mov       dx,word ptr ds:[PlayAdr+2]
;         call      SetRBook                 ; uloen sla rmeku
;
;         pop       ax                       ; poet sektor
;
;         add       word ptr ds:[PlayAdr],ax  ; zven ukazatele
;         adc       word ptr ds:[PlayAdr+2],0
;
;         stosw                              ; poet sektor
;         xor       ax,ax
;         stosw
;         jmp       short StopCD2

; -----------------------------------------------------------------------------
;        pokraovn v pehrvn
; -----------------------------------------------------------------------------

; ------ naten aktuln pozice

ContCD:  mov       word ptr ds:[ZarizBuf],1 + 1*256 ; zjitn pozice hlav
         mov       cx,5
         call      InpIOCTL                 ; naten absolutn pozice hlav
         mov       si,offset ZarizBuf+2
         call      GetRBook                 ; naten aktuln pozice hlav
         mov       word ptr ds:[PlayAdr],ax ; aktuln absolutn pozice
         mov       word ptr ds:[PlayAdr+2],dx

; Pokrauje PLAYCD !!!!

; -----------------------------------------------------------------------------
;        pehrt nahrvky
; -----------------------------------------------------------------------------

PlayCD   PROC      NEAR

; ------ inicializace bufferu poadavku

         call      NulPozad                 ; nulovn bufferu poadavku
         mov       al,16h                   ; dlka poadavku
         stosb
         mov       al,ds:[Disk]             ; aktivn disk
         stosb
         mov       al,84h
         stosb                              ; povel

         mov       di,offset Pozadav+0dh
         mov       al,1
         stosb

         mov       ax,word ptr ds:[PlayAdr]
         mov       dx,word ptr ds:[PlayAdr+2]
         call      SetRBook                 ; uloen sla rmeku

         mov       ax,word ptr ds:[KonecAdr] ; adresa konce
         mov       dx,word ptr ds:[KonecAdr+2]
         sub       ax,word ptr ds:[PlayAdr] ; zbvajc poet sektor
         sbb       dx,word ptr ds:[PlayAdr+2]
         jnc       PlayCD4
         mov       ax,1
         xor       dx,dx
PlayCD4: stosw                              ; poet sektor
         xchg      ax,dx
         stosw
         jmp       short StopCD2

PlayCD   ENDP

;; -----------------------------------------------------------------------------
;;        pokraovn v pehrvn CD-ROM
;; -----------------------------------------------------------------------------
;
;ContCD:  mov       al,88h
;         jmp       short StopCD1

; -----------------------------------------------------------------------------
;        zastaven pehrvn CD-ROM
; -----------------------------------------------------------------------------

StopCD   PROC      NEAR

         mov       al,85h                   ; STOP

; ------ inicializace bufferu poadavku

StopCD1: push      ax
         call      NulPozad                 ; nulovn bufferu poadavku
         mov       al,0dh                   ; dlka poadavku
         stosb
         mov       al,ds:[Disk]             ; aktivn disk
         stosb
         pop       ax
         stosb                              ; povel

; ------ vysln poadavku

StopCD2: mov       al,10h                   ; podfunkce ovldn zazen
         mov       cl,ds:[Disk]             ; aktivn disk
         mov       ch,0
         call      Int2F                    ; vysln poadavku

; ------ kontrola navrcenho stavu

         test      byte ptr ds:[Zadano],40h ; zobrazen ?
         jnz       StopCD9                  ; je zobrazen
         test      byte ptr ds:[Pozadav+3+1],80h ; byla chyba ?
         jz        StopCD9                  ; nebyla chyba
StopCD8: mov       dx,offset ReadyTxt       ; text - nen pipraven
         jmp       Chyba                    ; chyba

StopCD9: ret

StopCD   ENDP

; -----------------------------------------------------------------------------
;        nastaven ukazatele na DX:AX
; -----------------------------------------------------------------------------

SeekCD   PROC      NEAR

; ------ inicializace bufferu poadavku

         push      ax
         push      dx

         call      NulPozad                 ; nulovn bufferu poadavku
         mov       al,18h                   ; dlka poadavku
         stosb
         mov       al,ds:[Disk]             ; aktivn disk
         stosb
         mov       al,83h
         stosb                              ; povel

         mov       di,offset Pozadav+0dh

         mov       al,1
         stosb                              ; md adresovn

         mov       ax,offset Buffer         ; adresa bufferu
         stosw
         mov       ax,ds
         stosw

         mov       ax,1
         stosw                              ; poet sektor

         pop       dx
         pop       ax
         call      SetRBook                 ; uloen sla rmeku
         jmp       short StopCD2

SeekCD   ENDP

; -----------------------------------------------------------------------------
;        zobrazen stavu CD
; -----------------------------------------------------------------------------
;
DispCD   PROC      NEAR

;         and       byte ptr ds:[Param],not 1     ; nen rychlopehrvn

         mov       dx,offset StavTxt
         mov       ah,9
         int       21h

; ------ naten aktuln pozice

DispCD1: mov       word ptr ds:[ZarizBuf],1 + 1*256 ; zjitn pozice hlav
         mov       cx,5
         call      InpIOCTL                 ; naten absolutn pozice hlav
         mov       si,offset ZarizBuf+2
         call      GetRBook                 ; naten aktuln pozice hlav
         mov       word ptr ds:[AktAAdr],ax ; aktuln absolutn pozice
         mov       word ptr ds:[AktAAdr+2],dx

         push      ax
         push      dx
         call      TestCD
         pop       dx
         pop       ax
         jnc       DispCD12                 ; je v provozu
         add       word ptr ds:[AktAAdr],30 ; pi pauze nechv na rozjezd
         adc       word ptr ds:[AktAAdr+2],0

; ------ pehrn sektoru pi rychlopehrvn

DispCD12:
;test      byte ptr ds:[Param],1
;         jz        DispCD15
;
;         cmp       dx,word ptr ds:[PlayAdr+2]
;         jne       DispCD13
;         cmp       ax,word ptr ds:[PlayAdr]
;DispCD13:jb        DispCD15
;
;         call      StopCD
;
;         add       word ptr ds:[PlayAdr],3*75-10
;         adc       word ptr ds:[PLayAdr+2],0
;
;         call      PlayCD
;
;         add       word ptr ds:[PlayAdr],75
;         adc       word ptr ds:[PlayAdr+2],0
;
;;         mov       ax,75
;;         call      RychlCD                  ; rychlopehrvn

; ------ dekdovn aktuln absolutn pozice

DispCD15:mov       ax,word ptr ds:[AktAAdr]
         mov       dx,word ptr ds:[AktAAdr+2]
         sub       ax,word ptr ds:[BeginAdr] ; odeten potku asu
         sbb       dx,word ptr ds:[BeginAdr+2]
         mov       di,offset StavTxt2+44
         call      DekTimeH                 ; dekdovn asu ve tvaru MM:SS,FF

; ------ zbvajc as do konce disku

         mov       ax,word ptr ds:[KonecAdr]
         mov       dx,word ptr ds:[KonecAdr+2]
         sub       ax,word ptr ds:[AktAAdr]
         sbb       dx,word ptr ds:[AktAAdr+2]
         jnc       DispCD2
         xor       ax,ax
         xor       dx,dx
DispCD2: mov       di,offset StavTxt2+55
         call      DekTimeH                 ; dekdovn asu ve tvaru MM:SS,FF

; ------ velikost disku

         mov       ax,word ptr ds:[KonecAdr] ; konec disku
         mov       dx,word ptr ds:[KonecAdr+2]
         sub       ax,word ptr ds:[BeginAdr] ; velikost disku
         sbb       dx,word ptr ds:[BeginAdr+2]
         mov       di,offset StavTxt2+66
         call      DekTimeH

; ------ pprava k nalezen stopy

         mov       ax,word ptr ds:[BeginAdr]  ; adresa stopy 1
         mov       word ptr ds:[NextAdr],ax ; adresa pt stopy
         mov       ax,word ptr ds:[BeginAdr+2]
         mov       word ptr ds:[NextAdr+2],ax
         mov       al,ds:[BegTrack]         ; poten stopa

; ------ adresa aktuln stopy AL

DispCD3: mov       ds:[Track],al            ; nov aktuln stopa
         mov       ax,word ptr ds:[NextAdr]
         mov       word ptr ds:[TrackAdr],ax ; adresa aktuln stopy
         mov       ax,word ptr ds:[NextAdr+2]
         mov       word ptr ds:[TrackAdr+2],ax

; ------ naten informac pt stopy

         mov       al,ds:[Track]            ; aktuln stopa
         inc       ax                       ; pt stopa
         call      GetTrack                 ; parametry dal stopy
         mov       word ptr ds:[NextAdr],ax ; adresa dal stopy
         mov       word ptr ds:[NextAdr+2],dx

; ------ test, zda je ukazatel v tto stop

         sub       ax,word ptr ds:[AktAAdr] ; offset od aktulnho ukazatele
         sbb       dx,word ptr ds:[AktAAdr+2]
         ja        DispCD5                  ; stopa nalezena
         jb        DispCD4
         or        ax,ax
         jnz       DispCD5

; ------ test, zda je dal stopa

DispCD4: mov       al,ds:[Track]            ; aktuln stopa
         inc       ax                       ; nsledujc stopa
         cmp       al,ds:[EndTrack]         ; je jet dal stopa ?
         jbe       DispCD3                  ; stopa je jet platn
         xor       ax,ax                    ; nic nezbv
         xor       dx,dx

; ------ dekdovn zbvajcho asu do konce stopy

DispCD5: mov       di,offset StavTxt2+22
         call      DekTimeH                 ; dekdovn asu ve tvaru MM:SS,FF

; ------ as ve stop

         mov       ax,word ptr ds:[AktAAdr] ; aktuln as
         mov       dx,word ptr ds:[AktAAdr+2]
         sub       ax,word ptr ds:[TrackAdr]
         sbb       dx,word ptr ds:[TrackAdr+2]
         jnc       DispCD6
         xor       ax,ax
         xor       dx,dx

; ------ dekdovn asu ve stop

DispCD6: mov       di,offset StavTxt2+11
         call      DekTimeH                 ; dekdovn asu ve tvaru MM:SS,FF

; ------ dekdovn dlky stopy

         mov       ax,word ptr ds:[NextAdr]
         mov       dx,word ptr ds:[NextAdr+2]
         sub       ax,word ptr ds:[TrackAdr]
         sbb       dx,word ptr ds:[TrackAdr+2]
         mov       di,offset StavTxt2+33
         call      DekTimeH

; ------ dekdovn sla nahrvky

         mov       al,ds:[Track]            ; aktuln stopa
         mov       di,offset StavTxt2+4
         call      DekNumB                  ; dekdovn sla nahrvky
         cmp       byte ptr ds:[StavTxt2+4],"0"
         jne       DispCD7
         mov       byte ptr ds:[StavTxt2+4]," "

; ------ zobrazen aktulnho stavu

DispCD7: mov       dx,offset StavTxt2
         call      DispTxt

; ------ zobrazen stavu STOP

         call      TestCD
         mov       dx,offset StopTxt
         jc        DispCD70
         mov       dx,offset NStopTxt
DispCD70:call      DispTxt

; ------ korekce sla stopy, je-li na konci

         cmp       word ptr ds:[StavTxt2+22],"00" ; zbvajc as
         jne       DispCD72
         cmp       word ptr ds:[StavTxt2+22+3],"00"
         jne       DispCD72
         inc       byte ptr ds:[Track]      ; zven sla stopy

; ------ test, zda je stisk klvesy

DispCD72:mov       ah,1
         int       16h
         jnz       DispCD8
DispCD74:jmp       DispCD1

; ------ vstup znaku z klvesnice

DispCD8: mov       ah,0
         int       16h

; ------ peruen operace

         or        ax,ax
         jz        DspCD812
         cmp       al,27
         jne       DspCD814

; ------ oddkovn

DspCD812:mov       dx,offset CRTxt
         mov       ah,9
         int       21h
         ret

; ------ pedchoz nahrvka

DspCD814:cmp       ax,4800h                 ; nahoru
         jne       DispCD82
         mov       al,ds:[Track]            ; aktuln stopa
         dec       al                       ; snen sla stopy
         cmp       al,ds:[BegTrack]
         jae       DispCD81
         mov       al,ds:[EndTrack]         ; posledn stopa
DispCD81:call      GetTrack                 ; informace o nov stop
DspCD818:mov       word ptr ds:[PlayAdr],ax ; adresa k pehrt
         mov       word ptr ds:[PlayAdr+2],dx
         push      ax
         push      dx
         call      TestCD                   ; pehrv ?
         pop       dx
         pop       ax
         jc        DspCD819                 ; nepehrv
         call      StopCD                   ; zastaven pehrvn
         call      PlayCD                   ; pehrt nahrvky
         jmp       short DispCD74

DspCD819:call      PlayCD
         call      StopCD
         jmp       short DispCD74

; ------ nsledujc nahrvka

DispCD82:cmp       ax,5000h
         jne       DispCD83
         mov       al,ds:[Track]
         inc       al
         cmp       al,ds:[EndTrack]
         jbe       DispCD81
         mov       al,ds:[BegTrack]
         jmp       short DispCD81

; ------ posun o 15 sekund zpt

DispCD83:cmp       ax,4b00h
         jne       DispCD84
         mov       ax,word ptr ds:[AktAAdr] ; aktuln ukazatel
         mov       dx,word ptr ds:[AktAAdr+2]
         sub       ax,15*75                 ; posun o 15 sekund zpt
         sbb       dx,0
         jnc       DspCD832
         xor       ax,ax
         xor       dx,dx
DspCD832:jmp       short DspCD818

; ------ posun o 15 sekund vped

DispCD84:cmp       ax,4d00h
         jne       DispCD85
         mov       ax,word ptr ds:[AktAAdr] ; aktuln ukazatel
         mov       dx,word ptr ds:[AktAAdr+2]
         add       ax,15*75                 ; posun o 15 sekund zpt
         adc       dx,0
         cmp       dx,word ptr ds:[KonecAdr+2]
         jne       DspCD842
         cmp       ax,word ptr ds:[KonecAdr]
DspCD842:jb        DspCD844
         mov       ax,word ptr ds:[KonecAdr]
         mov       dx,word ptr ds:[KonecAdr+2]
         sub       ax,1
         sbb       dx,0
DspCD844:jmp       short DspCD832

; ------ pauza

DispCD85:cmp       al," "
         jne       DispCD86
         call      TestCD                   ; test, zda pehrv
         jnc       DspCD852                 ; pehrv
         call      ContCD                   ; pokraovn v pehrvn
DspCD851:jmp       DispCD1

DspCD852:call      StopCD                   ; zastaven pehrvn
         jmp       short DspCD851

; ------ start od skladby 1...

DispCD86:cmp       al,"a"
         jb        DspCD861
         cmp       al,"z"
         ja        DspCD861
         sub       al,32
DspCD861:cmp       al,"1"
         jb        DispCD87
         cmp       al,"Z"
         ja        DispCD87
         cmp       al,"9"
         jbe       DspCD862
         cmp       al,"A"
         jb        DispCD87
         sub       al,7
DspCD862:sub       al,"0"                   ; AL = slo skladby 1...
         cmp       al,ds:[EndTrack]
         ja        DispCD87
         call      GetTrack                 ; naten informac o stop
         mov       word ptr ds:[PlayAdr],ax ; adresa k pehrt
         mov       word ptr ds:[PlayAdr+2],dx
         call      StopCD                   ; zastaven pehrvn
         call      PlayCD                   ; pehrt nahrvky
         jmp       DispCD1

DispCD87:

; ------ rychlopehrvn
;cmp       al," "
;         jne       DispCD88
;
;         xor       byte ptr ds:[Param],1    ; zmna pznaku
;         test      byte ptr ds:[Param],1
;         jz        DspCD851
;
;         mov       word ptr ds:[ZarizBuf],1 + 1*256 ; zjitn pozice hlav
;         mov       cx,5
;         call      InpIOCTL                 ; naten absolutn pozice hlav
;         mov       si,offset ZarizBuf+2
;         call      GetRBook                 ; naten aktuln pozice hlav
;         add       ax,75
;         adc       dx,0
;         mov       word ptr ds:[PlayAdr],ax ; aktuln absolutn pozice
;         mov       word ptr ds:[PlayAdr+2],dx
;         call      StopCD
;;         mov       ax,75
;;         call      RychlCD
;         call      PlayCD
;         jmp       short DspCD851
;
DispCD88:jmp       DispCD72

DispCD   ENDP

;; -----------------------------------------------------------------------------
;;        ten disku CD-ROM
;; -----------------------------------------------------------------------------
;;
;ReadCD   PROC      NEAR
;
;         xor       bx,bx
;ReadCX1:
;         push      bx
;         mov       al,7
;         call      Int2f0
;         pop       bx
;         inc       bx
;         jnz       ReadCX1
;
;; ------ vytvoen vstupnho souboru
;
;         mov       dx,offset ReadSoub
;         mov       ah,3ch
;         xor       cx,cx
;         int       21h
;         jnc       ReadCD2
;ReadCD0: mov       dx,offset WritTxt
;         jmp       Chyba
;
;ReadCD2: mov       word ptr ds:[ReadIdnt],ax
;
;; ------ naten jednoho sektoru
;
;ReadCD3:
;         mov       di,word ptr ds:[BegSektR] ; ukazatel sla sektoru
;         mov       si,word ptr ds:[BegSektR+2]
;         mov       dx,1                     ; 1 sektor
;         mov       cl,ds:[Disk]             ; aktivn disk
;         mov       ch,0
;         mov       al,8
;         call      Int2F
;
;;call      NulPozad                 ; nulovn bufferu poadavku
;;         mov       al,27
;;         stosb                              ; dlka poadavku
;;         mov       al,ds:[Disk]             ; aktivn disk
;;         stosb
;;         mov       al,80h
;;         stosb                              ; povel
;;
;;         mov       di,offset Pozadav+0dh
;;         mov       al,0
;;         stosb                              ; adresovac md
;;         mov       ax,offset Buffer
;;         stosw                              ; offset bufferu
;;         mov       ax,ds
;;         stosw                              ; segment bufferu
;;         mov       ax,1
;;         stosw                              ; poet sektor - 1 sektor
;;         mov       ax,word ptr ds:[BegSektR] ; ukazatel sla sektoru
;;         mov       dx,word ptr ds:[BegSektR+2]
;;;         mov       cx,75                    ; poet sektor na sekundu
;;;         call      DivCX                    ; vpoet sla rmeku
;;;         mov       ds:[di],bl               ; slo rmeku
;;;         inc       di
;;;         mov       cl,60                    ; poet sekund na minutu
;;;         call      DivCX                    ; vpoet sla sekundy
;;;         mov       ds:[di],bl               ; slo sekundy
;;;         inc       di
;;;         mov       ah,0
;;         stosw                              ; slo minuty
;;         xchg      ax,dx
;;         stosw
;;
;;         mov       al,0
;;         stosb                              ; tec md 2048 bajt
;;         inc       ax                       ; AL <- 1
;;         stosb                              ; poet sektor na skupinu
;;         dec       ax                       ; AL <- 0
;;         stosb                              ; poet sektor mezi skupinami
;;
;;; ------ vysln poadavku
;;
;;         mov       al,10h                   ; podfunkce ovldn zazen
;;         mov       cl,ds:[Disk]             ; aktivn disk
;;         mov       ch,0
;;         call      Int2F                    ; vysln poadavku
;;         test      byte ptr ds:[Pozadav+3+1],80h ; byla chyba ?
;;         jz        ReadCD4                  ; nen chyba
;
;         jnc       ReadCD4
;
;         jmp       StopCD8                  ; byla chyba
;
;; ------ uloen sektoru do souboru
;
;ReadCD4: mov       dx,offset Pozadav
;         mov       ah,40h
;         mov       bx,ds:[ReadIdnt]         ; identifiktor souboru
;         mov       cx,2048                  ; velikost sektoru
;         int       21h                      ; zpis sektoru do souboru
;         jc        ReadCD5
;         cmp       ax,cx
;         je        ReadCD6
;ReadCD5: jmp       ReadCD0                  ; chyba
;
;; ------ zven sla sektoru
;
;ReadCD6: add       word ptr ds:[BegSektR],1 ; zven sla sektoru
;         adc       word ptr ds:[BegSektR+2],0
;
;; ------ test, zda jsou ji vechny sektory
;
;         mov       ax,word ptr ds:[BegSektR+2]
;         cmp       ax,word ptr ds:[EndSektR+2]
;         jne       ReadCD7
;         mov       ax,word ptr ds:[BegSektR]
;         cmp       ax,word ptr ds:[EndSektR]
;ReadCD7: jae       ReadCD8
;         jmp       ReadCD3
;
;; ------ uzaven souboru
;
;ReadCD8: mov       ah,3eh
;         int       21h
;         ret
;
;ReadCD   ENDP

; -----------------------------------------------------------------------------
;        nulovn bufferu poadavku pro IOCTL -> ES:DI=buffer
; -----------------------------------------------------------------------------

NulPozad PROC      NEAR

         push      ds
         pop       es
         mov       di,offset Pozadav        ; buffer poadavku
         mov       cx,100/2                 ; dlka bufferu
         xor       ax,ax
         cld
         push      di
         rep       stosw                    ; vynulovn bufferu
         pop       di
         ret

NulPozad ENDP

; -----------------------------------------------------------------------------
;        dekdovn asu MM:SS,FF bez omezen minut
; -----------------------------------------------------------------------------

DekTimeH PROC      NEAR

         call      DekMinH                  ; dekdovn minuty
         call      DekSeknd                 ; dekdovn sekund
         call      DekFrame                 ; dekdovn rmeku
         ret

DekTimeH ENDP

; -----------------------------------------------------------------------------
;        dekdovn asu MM:SS,FF
; -----------------------------------------------------------------------------

DekTimeF PROC      NEAR

         call      DekMinut                 ; dekdovn minuty
         call      DekSeknd                 ; dekdovn sekund
         call      DekFrame                 ; dekdovn rmeku
         ret

DekTimeF ENDP

; -----------------------------------------------------------------------------
;        dekdovn hodiny z asu DX:AX do bufferu ES:DI (1 slice)
; -----------------------------------------------------------------------------

DekHodin PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ vpoet slice hodiny

         mov       cx,75                    ; pro pepoet na sekundy
         call      DivCX                    ; pepoet na sekundy
         mov       cx,60*60                 ; pro pepoet na hodiny
         call      DivCX                    ; pepoet na hodiny

; ------ pprava slice hodin

         add       al,"0"+10                ; korekce na znak ASCII + 10
DekHodn2:sub       al,10                    ; posun o d dol
         cmp       al,"9"                   ; je slice OK ?
         ja        DekHodn2                 ; slice je jet velk

; ------ uloen slice hodiny

         cld
         stosb                              ; uloen slice hodiny
         inc       di                       ; peskoen oddlovae asu

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DekHodin ENDP

; -----------------------------------------------------------------------------
;        dekdovn minuty (bez omezen) z asu DX:AX do bufferu ES:DI
; -----------------------------------------------------------------------------

DekMinH  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ vpoet slice minut

         mov       cx,75*60                 ; pro pepoet na minuty
         call      DivCX                    ; pepoet na minuty

; ------ uloen sla minut

         call      DekNumB                  ; dekdovn sla minut
         inc       di                       ; peskoen oddlovae asu

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DekMinH  ENDP

; -----------------------------------------------------------------------------
;        dekdovn minuty z asu DX:AX do bufferu ES:DI (2 slice)
; -----------------------------------------------------------------------------

DekMinut PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ vpoet slice minut

         mov       cx,75*60                 ; pro pepoet na minuty
         call      DivCX                    ; pepoet na minuty
         mov       cx,60                    ; pro pepoet na hodiny
         call      DivCX                    ; pepoet na hodiny
         xchg      ax,bx                    ; AX <- zbyl st minut v hodin

; ------ uloen sla minut

         call      DekNumB                  ; dekdovn sla minut
         inc       di                       ; peskoen oddlovae asu

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DekMinut ENDP

; -----------------------------------------------------------------------------
;        dekdovn sekundy z asu DX:AX do bufferu ES:DI (2 slice)
; -----------------------------------------------------------------------------

DekSeknd PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ vpoet slice sekund

         mov       cx,75                    ; pro pepoet na sekundy
         call      DivCX                    ; pepoet na sekundy
         mov       cx,60                    ; pro pepoet na minuty
         call      DivCX                    ; pepoet na minuty
         xchg      ax,bx                    ; AX <- zbyl st sekund v minut

; ------ uloen sla sekund

         call      DekNumB                  ; dekdovn sla sekund
         inc       di                       ; peskoen oddlovae asu

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DekSeknd ENDP

; -----------------------------------------------------------------------------
;        dekdovn rmeku z asu DX:AX do bufferu ES:DI (2 slice)
; -----------------------------------------------------------------------------

DekFrame PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ vpoet sla rmeku

         mov       cx,75                    ; pro pepoet na sekundy
         call      DivCX                    ; pepoet na sekundy
         xchg      ax,bx                    ; AX <- zbyl st rmeku v sekund

; ------ pepoet rmeku na setiny sekundy (tj. rmeek * 100 / 75)

         mov       bx,100                   ; poet setin sekundy
         mul       bx                       ; pepoet na setiny sekundy * 75
         div       cx                       ; pepoet na setiny sekundy
         cmp       dx,35
         jb        DekFram2
         inc       ax                       ; zaokrouhlen nahoru

; ------ uloen sla rmeku

DekFram2:call      DekNumB                  ; dekdovn sla rmeku
         inc       di                       ; peskoen oddlovae asu

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DekFrame ENDP

; -----------------------------------------------------------------------------
;        vydlen DX:AX / CX (nesm bt 0 !) -> DX:AX, BX=zbytek
; -----------------------------------------------------------------------------

DivCX    PROC      NEAR

         xchg      ax,bx                    ; BX <- schova sla LOW
         xor       ax,ax                    ; AX <- 0
         xchg      ax,dx                    ; AX <- slo HIGH, DX <- 0
         div       cx                       ; vydlen sla HIGH
         xchg      ax,bx                    ; AX <- slo LOW, BX <- nov HIGH
         div       cx                       ; vydlen sla LOW
         xchg      bx,dx                    ; BX <- zbytek, DX <- nov HIGH
         ret

DivCX    ENDP

; -----------------------------------------------------------------------------
;        vynsoben sla DX:AX * CX -> BX:DX:AX
; -----------------------------------------------------------------------------

MulCX    PROC      NEAR

         push      si
         xchg      ax,si                    ; SI <- schova sla LOW
         xchg      ax,dx                    ; AX <- slo HIGH
         mul       cx                       ; vynsoben sla HIGH
         xchg      ax,si                    ; SI <- nov HIGH, AX <- star LOW
         mov       bx,dx                    ; BX <- nov 2HIGH
         mul       cx                       ; vynsoben sla LOW
         add       dx,si                    ; piten sla HIGH
         adc       bx,0                     ; penos 2HIGH
         pop       si
         ret

MulCX    ENDP

; -----------------------------------------------------------------------------
;        dekdovn sla AL do bufferu ES:DI
; -----------------------------------------------------------------------------

DekNumB  PROC      NEAR

         push      ax
         aam
         xchg      al,ah
         add       ax,"00"
         cld
         stosw
         pop       ax
         ret

DekNumB  ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla DX:AX
; -----------------------------------------------------------------------------

DispDNum PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      dx
         push      di

         xor       di,di                    ; ta slic
         mov       cx,10                    ; dlitel
DispDNm1:call      DivCX                    ; vydlen DX:AX / CX
         push      bx                       ; schova sice
         inc       di                       ; ta znak
         mov       bx,ax
         or        bx,dx                    ; je ji 0 ?
         jnz       DispDNm1                 ; dal slice

DispDNm2:pop       ax
         add       al,"0"                   ; korekce na znak ASCII
         call      DispChr                  ; zobrazen znaku
         dec       di
         jnz       DispDNm2

         pop       di
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DispDNum ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla AX
; -----------------------------------------------------------------------------

DispNum  PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      dx

         xor       cx,cx                    ; ta slic
         mov       bx,10                    ; dlitel
DispNum1:xor       dx,dx                    ; DX <- 0
         div       bx                       ; vpoet slice
         push      dx                       ; schova sice
         inc       cx                       ; ta znak
         or        ax,ax                    ; je ji 0 ?
         jnz       DispNum1                 ; dal slice

DispNum2:pop       ax
         add       al,"0"                   ; korekce na znak ASCII
         call      DispChr                  ; zobrazen znaku
         loop      DispNum2

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DispNum  ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla AL (2 slice)
; -----------------------------------------------------------------------------

Disp2Num PROC      NEAR

         push      ax
         aam
         xchg      al,ah
         add       ax,"00"
         call      DispChr                  ; prvn slice
         xchg      al,ah
         call      DispChr                  ; druh slice
         pop       ax
         ret

Disp2Num ENDP

; -----------------------------------------------------------------------------
;        zobrazen textu DOS DS:DX
; -----------------------------------------------------------------------------

DispTxt  PROC      NEAR

         push      ax
         mov       ah,9
         int       21h
         pop       ax
         ret

DispTxt  ENDP

; -----------------------------------------------------------------------------
;        zobrazen znaku DOS AL
; -----------------------------------------------------------------------------

DispChr  PROC      NEAR

         push      ax
         push      dx
         xchg      ax,dx
         mov       ah,2
         int       21h
         pop       dx
         pop       ax
         ret

DispChr  ENDP

; -----------------------------------------------------------------------------
;        inicializace disku
; -----------------------------------------------------------------------------

InitDisk PROC      NEAR

; ------ naten seznamu disk CD-ROM

         mov       byte ptr ds:[Pozadav],-1 ; neplatn disk
         mov       al,0dh
         call      Int2F                    ; naten seznamu disk

; ------ test, zda je instalovn OK

         mov       al,ds:[Pozadav]          ; prvn disk
         cmp       al,32                    ; je disk platn ?
         jae       InitDsk8                 ; chyba - asi nen ovlada
         mov       ds:[Disk],al             ; prvn disk CD-ROM
         add       byte ptr ds:[InfoTxt3],al ; oznaen disku
         ret

; ------ chyba - nen instalovn ovlada CD-ROM

InitDsk8:mov       dx,offset NicTxt
Chyba:   call      DispTxt
         mov       ax,4cffh
         int       21h

InitDisk ENDP

; -----------------------------------------------------------------------------
;        inicializace potu stop disku
; -----------------------------------------------------------------------------

InitTrk  PROC      NEAR

; ------ naten informac o disku

         mov       byte ptr ds:[ZarizBuf],0ah ; funkce parametr disku
         mov       word ptr ds:[ZarizBuf+1],0 ; neplatn hodnoty
         mov       cx,6                     ; poet tench bajt
         call      InpIOCTL                 ; naten stavu disku

; ------ kontrola prvn a posledn stopy

         mov       ax,word ptr ds:[ZarizBuf+1] ; prvn a posledn stopa
         or        al,al
         jz        InitTrk8                 ; neplatn daj
         or        ah,ah
         jz        InitTrk8                 ; neplatn daj
         cmp       ah,al                    ; poad stop OK
         jb        InitTrk8                 ; chyba
         cmp       ah,-1
         je        InitTrk8                 ; chyba
         mov       ds:[BegTrack],al         ; prvn stopa
         mov       ds:[EndTrack],ah         ; posledn stopa

; ------ koncov stopa

         mov       si,offset ZarizBuf+3     ; koncov adresa
         call      GetRBook                 ; naten koncovho rmeku
         mov       word ptr ds:[KonecAdr],ax ; rmeek konec
         mov       word ptr ds:[KonecAdr+2],dx

; ------ poten stopa

         mov       al,ds:[BegTrack]         ; poten stopa
         call      GetTrack                 ; naten potenho rmeku
         mov       word ptr ds:[BeginAdr],ax ; rmeek zatku
         mov       word ptr ds:[BeginAdr+2],dx
         mov       word ptr ds:[NextAdr],ax ; adresa pt stopy
         mov       word ptr ds:[NextAdr+2],dx
         mov       al,ds:[ZarizBuf+6]       ; stavov bajt
         mov       ds:[NextInfo],al         ; informan bajt
         ret

; ------ chyba - disk nen pipraven

InitTrk8:mov       dx,offset ReadyTxt       ; text - nen pipraven
         jmp       Chyba

InitTrk  ENDP

; -----------------------------------------------------------------------------
;        naten informac o stop AL -> DX:AX=poten rmeek
; -----------------------------------------------------------------------------

GetTrack PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      si

; ------ slo rmeku pro neplatn slo stopy

         cmp       al,ds:[EndTrack]         ; je stopa platn ?
         jbe       GetTrck4                 ; stopa je platn OK
         mov       ax,word ptr ds:[KonecAdr] ; adresa konce
         mov       dx,word ptr ds:[KonecAdr+2]
         jmp       short GetTrck8

; ------ naten informac o stop

GetTrck4:mov       byte ptr ds:[ZarizBuf],0bh ; funkce ten informac
         mov       byte ptr ds:[ZarizBuf+1],al ; stopa
         mov       cx,5
         call      InpIOCTL                 ; naten informac o stop

; ------ naten potenho asu stopy

         mov       si,offset ZarizBuf+2     ; poten as stopy
         call      GetRBook                 ; naten sla rmeku

; ------ nvrat registr

GetTrck8:pop       si
         pop       cx
         pop       bx
         ret

GetTrack ENDP

; -----------------------------------------------------------------------------
;        uloen sla rmeku DX:AX na adresu DS:DI (Red Book formt)
; -----------------------------------------------------------------------------

SetRBook PROC      NEAR

         push      bx
         push      cx

         cld
         mov       cx,75                    ; poet rmek na sekundu
         call      DivCX                    ; pepoet na sekundy
         mov       ds:[di],bl               ; slo rmeku
         inc       di

         mov       cl,60                    ; poet sekund na minutu
         call      DivCX                    ; pepoet na minuty
         mov       ds:[di],bl               ; slo sekundu
         inc       di

         stosw                              ; poet minut

         pop       cx
         pop       bx
         ret

SetRBook ENDP

; -----------------------------------------------------------------------------
;        naten sla rmeku z adresy DS:SI (Red Book formt) -> DX:AX
; -----------------------------------------------------------------------------

GetRBook PROC      NEAR

         mov       al,60                    ; poet sekund na minutu
         mul       byte ptr ds:[si+2]       ; pepoet minut na sekundy
         add       al,ds:[si+1]             ; piten sekund
         adc       ah,0
         mov       dx,75                    ; poet rmek na sekundu
         mul       dx                       ; pepoet sekund na rmeky
         add       al,ds:[si]               ; piten potu rmek
         adc       ah,0
         adc       dx,0
         ret

GetRBook ENDP

; -----------------------------------------------------------------------------
;        rozbor pkazovho dku (CY=chyba)
; -----------------------------------------------------------------------------
;
Rozbor   PROC      NEAR

         mov       si,81h

; ------ naten dalho znaku parametru

Rozbor1: call      RozbSpc                  ; vyputn mezer
         call      RozbChr                  ; naten dalho znaku
         jnc       Rozbor11                 ; je dal znak
         clc
         ret

; ------ "I" - vpis informac o disku

Rozbor11:cmp       al,"I"
         jne       Rozbor12
         or        byte ptr ds:[Zadano],1   ; pznak vpisu informac
         jmp       short Rozbor1

; ------ "L" - vpis obsahu disku

Rozbor12:cmp       al,"L"
         jne       Rozbor2
         or        byte ptr ds:[Zadano],2   ; pznak vpisu obsahu
         call      RozbTime                 ; naten asu potku
         mov       word ptr ds:[KorTime],ax ; as potku
         mov       word ptr ds:[KorTime+2],dx
         jmp       short Rozbor1

; ------ "S" - stop pehrvn

Rozbor2: cmp       al,"S"
         jne       Rozbor22
         or        byte ptr ds:[Zadano],4   ; zastaven pehrvn
         jmp       short Rozbor1

; ------ "C" - pokraovn v pehrvn

Rozbor22:cmp       al,"C"
         jne       Rozbor24
         or        byte ptr ds:[Zadano],8   ; pokraovn v pehrvn
         jmp       short Rozbor1

; ------ "R" - ten dat

Rozbor24:
;cmp       al,"R"
;         jne       Rozbor3
;         call      RozbChr                  ; naten dalho znaku
;         jc        Rozbor9                  ; chyba
;         cmp       al,"A"                   ; absolutn
;         jne       Rozbor25
;         or        byte ptr ds:[Zadano],10h ; absolutn ten
;
;         call      RozbSekt                 ; naten sla potenho sektoru
;         mov       word ptr ds:[BegSektR],ax ; poten sektor
;         mov       word ptr ds:[BegSektR+2],dx
;         mov       word ptr ds:[EndSektR],ax ; poten sektor
;         mov       word ptr ds:[EndSektR+2],dx
;         call      RozbOdd1                 ; vyputn oddlovae
;         jc        Rozbr244
;         call      RozbSekt                 ; naten sla koncovho sektoru
;         jnc       Rozbr242
;         mov       dx,word ptr ds:[KonecAdr+2]
;         mov       ax,word ptr ds:[KonecAdr]
;         sub       ax,1
;         sbb       dx,0
;Rozbr242:mov       word ptr ds:[EndSektR],ax ; koncov sektor
;         mov       word ptr ds:[EndSektR+2],dx
;Rozbr244:jmp       Rozbor1
;
;Rozbor25:
;
;
;
;
;Rozbor3:

; ------ "P" - pehrvn nahrvky

         cmp       al,"P"
         jne       Rozbor4
         or        byte ptr ds:[Zadano],20h
         call      RozbNum                  ; naten sla nahrvky
         or        ax,ax
         jnz       Rozbor34
         inc       ax
Rozbor34:or        ah,ah
         jz        Rozbor35
         mov       ax,0ffh
Rozbor35:cmp       al,ds:[EndTrack]
         jb        Rozbor36
         mov       al,ds:[EndTrack]
Rozbor36:call      GetTrack                 ; naten informac o stop
         mov       word ptr ds:[PlayAdr],ax ; adresa k pehrt
         mov       word ptr ds:[PlayAdr+2],dx
         jmp       short Rozbor1

; ------ "D" - zobrazen stavu

Rozbor4: cmp       al,"D"
         jne       Rozbor5
         or        byte ptr ds:[Zadano],40h ; zobrazen stavu
         jmp       short Rozbor1

; ------ "T" - test stavu disku

Rozbor5: cmp       al,"T"
         jne       Rozbor6
         or        byte ptr ds:[Zadano],80h ; test stavu disku
         jmp       Rozbor1

Rozbor6:

Rozbor9: stc                                ; pznak chyby - neplatn znak
         ret

Rozbor   ENDP

; -----------------------------------------------------------------------------
;        zadn asu ve tvaru HH:MM:SS -> DX:AX
; -----------------------------------------------------------------------------

RozbTime PROC      NEAR

; ------ schova registr

         push      bx
         push      cx

; ------ naten hodiny

         call      RozbOdd                  ; naten hodiny
         mov       dx,60                    ; poet minut na hodinu
         mul       dx                       ; pepoet hodin na minuty
         xchg      ax,bx                    ; BX <- schova minut LOW

; ------ naten minut

         call      RozbOdd                  ; naten minut
         add       ax,bx                    ; piten penosu z hodin
         adc       dx,0
         mov       cx,60
         call      MulCX                    ; pepoet na sekundy
         xchg      ax,bx                    ; BX <- schova sekund LOW

; ------ naten sekund

         call      RozbOdd                  ; naten sekund
         add       ax,bx                    ; piten penosu z minut
         adc       dx,0
         mov       cx,75
         call      MulCX                    ; pepoet na rmeky

; ------ nvrat registr

         pop       cx
         pop       bx
         ret

RozbTime ENDP

; -----------------------------------------------------------------------------
;        naten sla do AX s vyputnm oddlovae
; -----------------------------------------------------------------------------

RozbOdd  PROC      NEAR

         call      RozbNum                  ; naten sla do AX
RozbOdd1:push      ax                       ; schova sla v AX
         call      RozbSpc                  ; vyputn mezer
         call      RozbChr                  ; naten znaku
         jc        RozbOdd2
         cmp       al,":"
         je        RozbOdd2
         cmp       al,"-"
         je        RozbOdd2
         cmp       al,"."
         je        RozbOdd2
         cmp       al,","
         je        RozbOdd2
         dec       si
         stc
RozbOdd2:pop       ax
         ret

RozbOdd  ENDP

;; -----------------------------------------------------------------------------
;;        naten sla sektoru -> DX:AX
;; -----------------------------------------------------------------------------
;
;RozbSekt PROC      NEAR
;
;         call      RozbDNum                 ; naten 2slova
;         jc        RozbSkt4
;
;         cmp       dx,word ptr ds:[KonecAdr+2]
;         jne       RozbSkt2
;         cmp       ax,word ptr ds:[KonecAdr]
;RozbSkt2:jb        RozbSkt3
;
;         mov       dx,word ptr ds:[KonecAdr+2]
;         mov       ax,word ptr ds:[KonecAdr]
;         sub       ax,1
;         sbb       dx,0
;
;RozbSkt3:clc
;RozbSkt4:ret
;
;RozbSekt ENDP
;
; -----------------------------------------------------------------------------
;        naten sla do DX:AX
; -----------------------------------------------------------------------------

RozbDNum PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         xor       bx,bx                    ; BX = stada LOW
         xor       dx,dx                    ; DX = stada HIGH
         mov       cx,10                    ; nsobitel

; ------ naten prvn slice

         call      RozbSpc                  ; vyputn mezer
         call      RozbNm                   ; naten prvn slice
         jc        RozbDNm9                 ; chyba

; ------ pidn slice AL ke stadai

RozbDNm2:mov       ah,0
         push      ax                       ; nov slice
         xchg      ax,bx                    ; AX <- stada
         call      MulCX                    ; vynsoben stadae
         pop       bx                       ; BX <- nov slice
         add       bx,ax                    ; piten sla ke stadai
         adc       dx,0

; ------ naten dal slice

         call      RozbNm                   ; naten dal slice
         jnc       RozbDNm2                 ; je dal slice OK
         clc                                ; pznak zadn OK

; ------ nvrat registr

RozbDNm9:xchg      ax,bx                    ; AX <- slo LOW
         pop       cx
         pop       bx
         ret

RozbDNum ENDP

; -----------------------------------------------------------------------------
;        naten sla do AX
; -----------------------------------------------------------------------------

RozbNum  PROC      NEAR

; ------ schova registr

         push      bx
         push      dx
         xor       bx,bx                    ; BX <- stada

; ------ naten prvn slice

         call      RozbSpc                  ; vyputn mezer
         call      RozbNm                   ; naten prvn slice
         jc        RozbNum9                 ; chyba

; ------ pidn slice AL ke stadai

RozbNum2:mov       ah,0
         xchg      ax,bx                    ; BX <- nov slice, AX <- stada
         mov       dx,10
         mul       dx                       ; stada * 10
         add       bx,ax                    ; piten sla ke stadai

; ------ naten dal slice

         call      RozbNm                   ; naten dal slice
         jnc       RozbNum2                 ; je dal slice OK
         clc                                ; pznak zadn OK

; ------ nvrat registr

RozbNum9:xchg      ax,bx                    ; AX <- slo
         pop       dx
         pop       bx
         ret

RozbNum  ENDP

; -----------------------------------------------------------------------------
;        naten jedn slice
; -----------------------------------------------------------------------------

RozbNm   PROC      NEAR

         call      RozbChr                  ; naten znaku
         jc        RozbNm9                  ; nen dal znak
         cmp       al,"0"
         jb        RozbNm8
         cmp       al,"9"+1
         cmc
         jc        RozbNm8
         sub       al,"0"
         ret

RozbNm8: dec       si
RozbNm9: ret

RozbNm   ENDP

; -----------------------------------------------------------------------------
;        vyputn mezer z pkazovho dku
; -----------------------------------------------------------------------------

RozbSpc  PROC      NEAR

         call      RozbChr
         jc        RozbSpc2
         je        RozbSpc
         dec       si
RozbSpc2:ret

RozbSpc  ENDP

; -----------------------------------------------------------------------------
;        naten znaku z pkazovho dku
; -----------------------------------------------------------------------------

RozbChr  PROC      NEAR

         cld
         lodsb

         cmp       al,9
         jne       RozbChr2
         mov       al," "

RozbChr2:cmp       al,"a"
         jb        RozbChr4
         cmp       al,"z"
         ja        RozbChr4
         sub       al,32

RozbChr4:cmp       al," "
         jae       RozbChr6
         dec       si

RozbChr6:ret

RozbChr  ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 2Fh s schovou registr (me navracet i CF !)
; -----------------------------------------------------------------------------

Int2F    PROC      NEAR

         mov       bx,offset Pozadav        ; buffer poadavku

Int2F0:  push      si
         push      di
         push      bp
         push      ds
         push      es

         push      ds
         pop       es                       ; segment bufferu
         mov       ah,15h
         int       2fh

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         ret

Int2F    ENDP

; -----------------------------------------------------------------------------
;        data
; -----------------------------------------------------------------------------
;
Zadano   db        0                        ; zadan parametry
                                            ;   bit 0: 1=vpis informac o disku
                                            ;   bit 1: 1=vpis obsahu disku
                                            ;   bit 2: 1=STOP pehrvn
                                            ;   bit 3: 1=pokraovn pehrvn
;                                            ;   bit 4: 1=absolutn ten
                                            ;   bit 5: 1=pehrvn nahrvky
                                            ;   bit 6: 1=zobrazen stavu
                                            ;   bit 7: 1=test stavu disku

;Param    db        0                        ; parametry
;                                            ;   bit 0: 1=rychlopehrvn

;CopyrTxt db        'Copyright disku CD-ROM: "$'

HelpTxt  db        13,10,'CDPLAY v 0.97 - prehravac audio CD disku; (c) Miroslav Nemecek',13,10
         db        'Zadejte:  I ........... zobrazeni informaci o disku',13,10
         db        '          L ........... vypis obsahu disku',13,10
         db        '          L hh:mm:ss .. vypis obsahu s prictenim casu',13,10
         db        '          S ........... STOP, pauza prehravani',13,10
         db        '          C ........... CONTINUE, pokracovani v prehravani',13,10
         db        '          P n ......... PLAY, prehravani od nahravky n (impl. n=1)',13,10
         db        '          T ........... test stavu disku - navraci navratovy kod:',13,10
         db        '                                     0 = probiha prehravani',13,10
         db        '                                     1 = neprobiha prehravani',13,10
         db        '                                   255 = chyba',13,10
;         db        '          P n1-n2 ..... PLAY, prehravani od nahravky n1 po n2',13,10
;         db        '          P ........... play, pokracovani prehravani',13,10
;         db        '          RA n1 - n2 .. absolutni cteni od sektoru n1 po n2',13,10
;         db        '                        (data se ulozi do souboru CDROM.TMP)',13,10
;         db        '          N ........... nasledujici nahravka',13,10
;         db        '          B ........... predchozi nahravka',13,10
;         db        '          P n ......... prehravani od nahravky n (n=1...)',13,10
         db        '          D ........... zobrazeni stavu prehravani',13,10
         db        13,10
         db        '$'

InfoTxt1 db        'Detekovan ovladac CD-ROM disku verze $'
InfoTxt2 db        13,10,'Disk nainstalovan jako logicky disk '
InfoTxt3 db        'A:',13,10
         db        'Pocet nahravek na disku: $'
InfoTxt4 db        13,10
         db        'Celkova hraci doba disku: '
InfoTx42 db        '0:00:00,00',13,10
         db        'Velikost jednoho sektoru: $'
InfoTxt5 db        ' bajtu',13,10
         db        'Celkova velikost disku: $'
InfoTxt6 db        ' sektoru ($'
InfoTxt7 db        ' MB)',13,10
         db        13,10
         db        '$'

ReadyTxt db        'Disk CD-ROM neni pristupny !',13,10,'$'
NicTxt   db        'Neni nainstalovan ovladac CD-ROM disku !',13,10,'$'

StavTxt  db        13,10
         db        'Ovladani:       nahoru/dolu = nahravka zpet/vpred',13,10
         db        '               vlevo/vpravo = posun o 15 sekund zpet/vpred',13,10
         db        '                     mezera = zastaveni/pokracovani prehravani',13,10
         db        '                        ESC = preruseni zobrazeni',13,10
         db        '                   1-9, A-Z = start od skladby 1...',13,10
;         db        '                     mezera = rychlopehrvn zap/vyp',13,10
         db        13,10
StavTxt1 db           'nahravka   cas      zbyva     delka    cas abs. zbyva abs.delka abs.',13,10
StavTxt2 db        13,'    1    00:00,00  00:00,00  00:00,00  00:00,00  00:00,00  00:00,00 $'
StopTxt  db        'STOP$'
NStopTxt db        '    $'

;WritTxt  db        'Chyba zapisu do vystupniho souboru CDROM.TMP !',13,10,'$'
;ReadSoub db        'CDROM.TMP',0
;ReadIdnt dw        0

StopaTxt db        '0:00:00 ( 1) ..........................................................'
StopaTx2 db        '00:00,00$'

DataTxt  db        ' DATA$'
QuadTxt  db        ' QUADRO$'
PreemTxt db        ' PREEM$'
ProtTxt  db        ' COPY$'

CRTxt    db        13,10,'$'

KonecTxt db        '0:00:00                                                       celkem '
KonecTx2 db        '  00:00,00',13,10,'$'

BegSektR dd        0                        ; poten sektor ten
EndSektR dd        0                        ; koncov sektor ten

KorTime  dd        0                        ; as potku vpisu

AktAAdr  dd        0                        ; aktuln absolutn pozice hlav

PlayAdr  dd        0                        ; adresa pro pehrt nahrvky

BeginAdr dd        0                        ; rmeek zatku (stopa 1)
KonecAdr dd        0                        ; rmeek konce (vbh CD-ROM)

TrackAdr dd        0                        ; adresa aktuln stopy
TrckInfo db        0                        ; INFO bajt aktuln stopy
                                            ;  bit 4: 1=preemfze audio stopy
                                            ;  bit 5: 1=zkaz digitln kopie
                                            ;  bit 6: 1=datov stopa, 0=audio
                                            ;  bit 7: 1=4 kanly, 0=2 kanly

NextAdr  dd        0                        ; adresa pt stopy
NextInfo db        0                        ; INFO bajt pt stopy

; ------ ukazatel stop disku

Track    db        0                        ; aktuln stopa 1...
BegTrack db        0                        ; poten stopa
EndTrack db        0                        ; koncov stopa
Disk     db        -1                       ; aktivn disk 0...

; ------ buffery

Pozadav  db        100 dup(?)               ; poadavek na ovlada CD-ROM
ZarizBuf db        100 dup(?)               ; buffer zhlav pstupu k zazen

Buffer   db        2048 dup(?)              ; buffer pro naten sektoru

Code     ENDS
         END       Start
